#ifndef __DS1302_H__
#define __DS1302_H__

#include <config.h>

//DS1302 IO
sbit DS1302_ACC = P2^3; 
sbit DS1302_GND = P2^4;      //ʵʱʱGND
sbit DS1302_CLK = P2^5;      //ʵʱʱʱ 
sbit DS1302_IO = P2^6;      //ʵʱʱ
sbit DS1302_RST = P2^7;      //ʵʱʱӸλ


 

//궨
#define DS1302_SECOND	0x80
#define DS1302_MINUTE	0x82
#define DS1302_HOUR		0x84 
#define DS1302_DAY		0x86
#define DS1302_MONTH	0x88
#define DS1302_WEEK		0x8a
#define DS1302_YEAR		0x8c 
#define hh				DS1302Buffer.Hour                //̫,תһ
#define mm				DS1302Buffer.Minute               //
#define ss				DS1302Buffer.Second              //


typedef struct __SYSTEMTIME__
{
	unsigned char Second;
	unsigned char Minute;
	unsigned char Hour;
	unsigned char Week;
	unsigned char Day;
	unsigned char Month;
	unsigned char  Year;
}SYSTEMTIME;	//ʱ


//߱
extern void DS1302_InputByte(unsigned char dat);
extern unsigned char DS1302_OutputByte(void) ;
extern void DS1302_Write(unsigned char ucAddr, unsigned char ucDa);
extern unsigned char DS1302_Read(unsigned char ucAddr);
extern void DS1302_SetProtect(unsigned char flag) ;
extern void DS1302_SetTime(unsigned char Address, unsigned char Value);
extern void DS1302_GetTime(SYSTEMTIME *Time);
extern void DS1302_Init(void);
extern void DS1302_ON_OFF(bit FLAG_ON_OFF);
//extern void DS1302_Update(SYSTEMTIME *Time);


extern SYSTEMTIME DS1302Buffer;
extern bit Flag_Time_Refresh;

#endif